from Products.CMFCore.utils import getToolByName
from Products.ExternalMethod.ExternalMethod import ExternalMethod

def installWorkflows(self, package, out):
    """Install the custom workflows for this product.
    """

    productname = 'EduploneExam'
    workflowTool = getToolByName(self, 'portal_workflow')

    ourProductWorkflow = ExternalMethod('temp',
                         'temp',
                         productname+'.'+'eXamFolderStates',
                         'createeXamFolderStates')
    workflow = ourProductWorkflow(self, 'eXamFolderStates')
    workflowTool._setObject('eXamFolderStates', workflow)
    workflowTool.setChainForPortalTypes(['ExamFolder'], workflow.getId())

    return workflowTool
