# File: FreeTextAnswer.py
# 
# Copyright (c) 2006 by eduplone Open Source Business Network EEIG, contributed
# by FH-Aargau, Switzerland
# Generator: ArchGenXML Version 1.4.0-RC1 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Nils Haagen <nhaagen@philter.de>, Jens Klein <jens.klein@jensquadrat.com>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from BaseAnswer import BaseAnswer


# additional imports from tagged value 'import'
from Products.EduploneExam.registry import registerAnswerType

from Products.EduploneExam.config import *
##code-section module-header #fill in your manual code here
import re
##/code-section module-header

schema=Schema((
    LinesField('correct',
        widget=LinesWidget(
            label="correct_textl",
            label_msgid="EduploneExam_label_correct_textl",
            description_msgid="EduploneExam_help_correct_textl",
            i18n_domain='EduploneExam',
        )
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

FreeTextAnswer_schema = BaseSchema + \
    getattr(BaseAnswer,'schema',Schema(())) + \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class FreeTextAnswer(BaseAnswer,BaseContent):
    """
    <p>Represents ...</p>
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseAnswer,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'FreeTextAnswer'

    meta_type                  = 'FreeTextAnswer'
    portal_type                = 'FreeTextAnswer'
    allowed_content_types      = [] + list(getattr(BaseAnswer, 'allowed_content_types', []))
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'FreeTextAnswer.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "FreeTextAnswer"
    typeDescMsgId              = 'description_edit_freetextanswer'

    schema = FreeTextAnswer_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods
    #manually created methods

    security.declarePublic('processValue')
    def processValue(self, value=''):
        '''
        value is some text. processValue tests all words 
        from self.correct for existence 
        '''
        counter = 0
        for word in self.getCorrect():
            if re.match("(?i).*(%s).*" % word, value) != None:
                counter += 1
            """if word in value:
                return True
            else:
                return False"""
        return counter



registerType(FreeTextAnswer,PROJECTNAME)
# end of class FreeTextAnswer

##code-section module-footer #fill in your manual code here
registerAnswerType(FreeTextAnswer)
##/code-section module-footer



