# File: SingleChoiceAnswer.py
# 
# Copyright (c) 2006 by eduplone Open Source Business Network EEIG, contributed
# by FH-Aargau, Switzerland
# Generator: ArchGenXML Version 1.4.0-RC1 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Nils Haagen <nhaagen@philter.de>, Jens Klein <jens.klein@jensquadrat.com>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from BooleanAnswer import BooleanAnswer


# additional imports from tagged value 'import'
from Products.EduploneExam.registry import registerAnswerType

from Products.EduploneExam.config import *
##code-section module-header #fill in your manual code here
from types import StringTypes
##/code-section module-header

schema=Schema((
),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

SingleChoiceAnswer_schema = BaseSchema + \
    getattr(BooleanAnswer,'schema',Schema(())) + \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class SingleChoiceAnswer(BooleanAnswer):
    """
    answer type with special single-choice validator
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BooleanAnswer,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'SingleChoiceAnswer'

    meta_type                  = 'SingleChoiceAnswer'
    portal_type                = 'SingleChoiceAnswer'
    allowed_content_types      = [] + list(getattr(BooleanAnswer, 'allowed_content_types', []))
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'SingleChoiceAnswer.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "SingleChoiceAnswer"
    typeDescMsgId              = 'description_edit_singlechoiceanswer'

    schema = SingleChoiceAnswer_schema

    ##code-section class-header #fill in your manual code here
    
    security.declarePublic('processValue')
    def processValue(self, value=None):
    	"""
    		Override function as strict mode is default by now
    	"""
    	if type(value) in StringTypes and value.lower() in ['0', 'false']:
            value=False
        if type(value) in StringTypes and value.lower() in ['on', 'true']:
            value=True

        if value:
            value=True
        else:
            value=False    

    	if self.getCorrect() == True and value == True:
    		return True
    	else:
    		return False
    
    ##/code-section class-header


    #Methods
    #manually created methods

    security.declarePublic('processValue')
    def processValue(self, value=None):
    	"""
    		Override function as strict mode is default by now
    	"""
    	if type(value) in StringTypes and value.lower() in ['0', 'false']:
            value=False
        if type(value) in StringTypes and value.lower() in ['on', 'true']:
            value=True

        if value:
            value=True
        else:
            value=False    

    	if self.getCorrect() == True and value == True:
    		return True
    	else:
    		return False
    


registerType(SingleChoiceAnswer,PROJECTNAME)
# end of class SingleChoiceAnswer

##code-section module-footer #fill in your manual code here
registerAnswerType(SingleChoiceAnswer)
##/code-section module-footer



