## Controller Python Script "exam_fillgap_process"
##title=Edit content
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=id=''

request = context.REQUEST

answerTitle = request.get("title")
answerCorrect = request.get("correct")
answerCaseSensitive = request.get("caseSensitive")
answerCreated = request.get("created")
answer = context
gapWordIndex = int(request.get("gapWordIndex"))

parent=context.aq_parent

answerId = context.getId() #request.get("id")
basetext = parent.getBasetextAsList()
options=request.get("options")


# Re-render basetext with newly added gap.
basetext_new = []
counter=0
for i in basetext:
    # Check if gap position has changed and move gap if so.
    if parent.getGapPosition(answerId) != gapWordIndex and i == "<id='%s'>" % answerId:
        basetext_new.append(answer.getCorrect()[0])
    else:
        if gapWordIndex == counter:
            basetext_new.append("<id='%s'>" % answerId)
        else:
            basetext_new.append(i)
    counter+=1

# Save settings
parent.setBasetext(" ".join(basetext_new))
answer.setTitle(answerTitle)
answer.setCorrect(answerCorrect)
answer.setCreated(True)

if answer.meta_type=="BlindGapAnswer":
    answer.setCaseSensitive(answerCaseSensitive)

if answer.meta_type=="ChoiceGapAnswer":
    answer.setOptions(options)

# Return to fillgap task
request.RESPONSE.redirect("%s" % context.absolute_url())
