# File: TextLineAnswer.py
# 
# Copyright (c) 2006 by eduplone Open Source Business Network EEIG, contributed
# by FH-Aargau, Switzerland
# Generator: ArchGenXML Version 1.4.0-RC1 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Nils Haagen <nhaagen@philter.de>, Jens Klein <jens.klein@jensquadrat.com>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from BaseAnswer import BaseAnswer


# additional imports from tagged value 'import'
from Products.EduploneExam.registry import registerAnswerType

from Products.EduploneExam.config import *
##code-section module-header #fill in your manual code here
##/code-section module-header

schema=Schema((
    LinesField('correct',
        widget=LinesWidget(
            label="Correct_textl",
            label_msgid="EduploneExam_label_correct_textl",
            description_msgid="EduploneExam_help_correct_textl",
            i18n_domain='EduploneExam',
        )
    ),

    BooleanField('caseSensitive',
        widget=BooleanWidget(
            label='Casesensitive',
            label_msgid='EduploneExam_label_caseSensitive',
            description_msgid='EduploneExam_help_caseSensitive',
            i18n_domain='EduploneExam',
        )
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

TextLineAnswer_schema = getattr(BaseAnswer,'schema',Schema(())) + \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class TextLineAnswer(BaseAnswer,BaseContent):
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseAnswer,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)


    allowed_content_types      = [] + list(getattr(BaseAnswer, 'allowed_content_types', []))
    schema = TextLineAnswer_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods
    #manually created methods

    security.declarePublic('processValue')
    def processValue(self, value=''):
        '''
        
        '''
        if value==None: 
            value=''
            
        if not self.caseSensitive:
            li=[]
            for i in self.getCorrect():
                li.append(i.lower())
            
            value=value.lower()
            
        else:
            li=self.getCorrect()

            
        if value in li: 
            return True
        else: 
            return False


# end of class TextLineAnswer

##code-section module-footer #fill in your manual code here
##/code-section module-footer



